#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <asm/types.h>
#include <linux/videodev.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <asm/types.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <errno.h>
#include <time.h>
#include <math.h>
//#include <stdarg.h>


/* CARACTERISTIQUES DE LA WEBCAM:
 * Quickcam zoom (logitech)
 * peut donner du 160x120 jusqu' 640x480
 * la sortie est en YUV420P
 */

static int fd;
static struct video_mmap grab_buf;
static int grab_size;
static unsigned char *data;

void capture_init(int largeur,int hauteur)
{
  if( (fd = open("/dev/video",O_RDWR) )== -1){
    perror("capture : open videodev");
    return;
  }

  grab_buf.frame=0;
  grab_buf.width=largeur;
  grab_buf.height=hauteur;
  grab_buf.format= VIDEO_PALETTE_YUV420P; 

  grab_size = grab_buf.width * grab_buf.height * 12 / 8;
  
  data = (unsigned char*)mmap(0,grab_size,PROT_READ|PROT_WRITE,MAP_SHARED,fd,0);
  
}

/* Cette fonction remplis out avec une image 
 * dcrite en YUV420P(12 bits), donc de taille 
 * largeur*hauteur*12/8
 */
void capture_grab(unsigned char *out,int largeur,int hauteur)
{
  if(out==NULL){
    perror("capture : first argument canot be NULL");
    return;
  }

  if (-1 == ioctl(fd,VIDIOCMCAPTURE,&grab_buf)) 
    perror("ioctl VIDIOCMCAPTURE"); 
  else
    if (-1 == ioctl(fd,VIDIOCSYNC,&grab_buf.frame))
      perror("ioctl VIDIOCSYNC");
    else {
      memcpy(out,data,grab_size);
    }

}

void capture_end()
{
  munmap(data,grab_size);
  close(fd);
}

/*
void capture(unsigned char *out,int largeur,int hauteur){
  video_init(largeur,hauteur);
  video_grab(out,largeur,hauteur);
  video_end();
  return;
}
*/
