#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>

#include "traitement.h"
#include "reflexion.h"
#include "kuka.h"
#include "calibrage.h"

#define HUMAIN 1
#define ORDI 2

void sigIntHandler()
{ 		 
  signal(SIGINT, sigIntHandler);
  printf("you have pressed ctrl-c \n");

  kuka_end();
  morpion_end();

  exit(0);
}

void sigAlarmHandler()
{ 		 
  signal(SIGALRM, sigAlarmHandler);
  printf("Timeout !!\n");

  kuka_end();
  morpion_end();

  exit(0);
}

int argc;
char **argv;

int main(int _argc, char **_argv)
{

  unsigned char jeux[9]={0};
  short reserve_ordi=-1,reserve_humain=-1,pion=0;
  int x_ordi=0,x_humain=0;
  int x=0,y=0;
  enum{personne=0,ordi=ORDI,humain=HUMAIN} gagnant=0;
  int jouable=1;
  pid_t my_pid, child_pid;

  argc=_argc;
  argv=_argv;
  
  my_pid=getpid();
  if( argc >=2 ){
    if( strcmp(argv[1],"-c")==0 || strcmp(argv[1],"--calibre")==0 ){
      child_pid=fork();
      if( child_pid==0 )
	calibrage_set();
      else
	wait(NULL);
    }
    else
      printf("Usage : %s [-c | --calibre]\n",argv[0]);
  }

  printf("Et c'est partit!!\nVrifiez d'avoir lanc le programem de commande et appuyer sur [entrer]\n");
  getchar();
  signal(SIGINT, sigIntHandler);
  signal(SIGALRM, sigAlarmHandler);

  morpion_init();
  kuka_init_all();
  calibrage_get();

  printf("A vous de commencer.\n");

  while(!gagnant && jouable){
    printf("Appuyez sur [enter] quand ce sera mon tour.");
    getchar();

    // ON REGARDE CE QUE L'HUMAIN A FAIT
    printf("Le jeux :\n");
    kuka_capture();
    sleep(2);
    morpion_get_etat(jeux,HUMAIN);
    morpion_display_etat(jeux);

    // ON JOUE
    printf("A mon tour.\n");

    x_ordi=complement(jeux,ORDI);
    x_humain=complement(jeux,HUMAIN);
    /* les lignes sont faites */
    if( (x=x_ordi) == -1 ){
      printf("Kuka a trois pions d'aligns.\n");
      jouable=0;
      gagnant=ORDI;
    }
    else if( (x=x_humain) == -1 ){
      printf("Vous avez trois pions aligns.\n");
      jouable=0;	
      gagnant=HUMAIN;
    }
    /* on fait ou on empeche une ligne */
    else if( (x=x_ordi) >= 0 ){
      printf("Kuka fait une ligne.\n");
      gagnant=ORDI;
      
    }
    else if( (x=x_humain) >=0 ){
      printf("Kuka vous empeche de faire une ligne.\n");
    }
    /* on fait n'importe quoi */  
    else {
      printf("Kuka joue au hazard.\n");
      x=0;
      while(jeux[x]!=0 && x<9) x++;
      if(x==9) jouable=0; // on ne peut plus jouer
    }

    if(jouable){
      printf("prend(%d,%d)\n",reserve_ordi,-1);
      kuka_prend(reserve_ordi,-1);
      reserve_ordi++;
      
      printf("pose(%d,%d)\n",x,2-y);
      jeux[x]=ORDI;
      y=x/3;
      x=x%3;
      kuka_pose(x,2-y);
    }

    printf("Le jeux :\n");
    morpion_display_etat(jeux);
  }

  switch(gagnant){
  case HUMAIN:
    printf("Humain");
    break;
  case ORDI:
    printf("Ordi");
    break;
  default:
    printf("Personne");
    break;
  }
  printf(" a gagn.\n");

  /*rangement */
  pion=0;
  while(pion<9){
    y=pion/3;
    x=pion%3;
    if(jeux[pion])
      kuka_prend(x,2-y);
    if(jeux[pion]==ORDI){
      reserve_ordi--;
      kuka_pose(reserve_ordi,-1);
    }   
    else if(jeux[pion]==HUMAIN){
      kuka_pose(reserve_humain,3);
      reserve_humain++;
    }    
    pion++;
  }
  kuka_end();
  morpion_end();
  return 0;
}
