#include <stdio.h>
#include <string.h>

/* Cette fonction retourne :
 * la case  jouer pour faire une ligne si deux pions sont aligns,
 * -1 si dj trois pions sont aligns,
 * -2 si on peut jouer au hazard.
 * ATTENTION, le jeux doit etre un plateau de 3x3,
 * donc sizeof(jeux_in)==9,
 * aussi, les cases du plateau valent (1..n) si un pion est dessus,
 * 0 sinon.
 */
int complement(unsigned char*jeux,int joueur)
{
  int j=0;
  int colonnes=3;
  unsigned char *ligne;
  int pions=0;
 
  /* pour les lignes diagonales */
  pions= (jeux[0]==joueur?1:0) + (jeux[4]==joueur?1:0) + (jeux[8]==joueur?1:0);
  //printf("pions=%d\n",pions);
  switch( pions ){
  case 0:
  case 1:
    break;
  case 2:
    if     ( jeux[0]==0 ) return 0;
    else if( jeux[4]==0 ) return 4;
    else if( jeux[8]==0 ) return 8;
    break;
  case 3:
    return -1;
    break;
  }

  pions= (jeux[2]==joueur?1:0) + (jeux[4]==joueur?1:0) + (jeux[6]==joueur?1:0);
  //printf("Nombre de pion sur diag 2 pions=%d\n",pions);
  switch( pions ){
  case 0:
  case 1:
    break;
  case 2:
    printf("ligne diagonale 2.\n");
    if     ( jeux[2]==0 ) return 2;
    else if( jeux[4]==0 ) return 4;
    else if( jeux[6]==0 ) return 6;
    break;
  case 3:
    return -1;
    break;
  }

  /* pour les lignes horizontales */
  for(j=0;j<3;j++){
    ligne=&jeux[j*colonnes];
    pions=(ligne[0]==joueur?1:0) + (ligne[1]==joueur?1:0) + (ligne[2]==joueur?1:0);
    switch(pions){
    case 0:
    case 1:
      break;
    case 2:
      if     ( ligne[0]==0 ) return j*colonnes+0;
      else if( ligne[1]==0 ) return j*colonnes+1;
      else if( ligne[2]==0 ) return j*colonnes+2;
      break;
    case 3:
      return -1;
      break;
    }
  }
 
  /* pour les lignes verticales*/
  for(j=0;j<3;j++){
    ligne=&jeux[j];
    pions=(ligne[0]==joueur?1:0) + (ligne[3]==joueur?1:0) + (ligne[6]==joueur?1:0);
    switch(pions){
    case 0:
    case 1:
      break;
    case 2:
      if     ( ligne[0]==0 ) return j+0;
      else if( ligne[3]==0 ) return j+3;
      else if( ligne[6]==0 ) return j+6;
      break;
    case 3:
      return -1;
      break;
    }
  }

  /* pour construire */
  /*
    pions=(jeux[0]==joueur?1:0) + (jeux[2]==joueur?1:0) + (jeux[8]==joueur?1:0);
    switch(pions){
    case 0: return 0; break;
    case 1: 
    case 2: return jeux[0]==0?0:jeux[2]==0?2:8; break;
    }
  */
  return -2;
}
